unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Buttons, ExtCtrls, ComCtrls, StdCtrls, Spin,
  MDIDEdit;

type
  TFMain = class(TForm)
    Panel1: TPanel;
    BnDateiOeffnen: TSpeedButton;
    BnSaveFile: TSpeedButton;
    BnNeu: TSpeedButton;
    BnUndo: TSpeedButton;
    BnCut: TSpeedButton;
    BnCopy: TSpeedButton;
    BnPaste: TSpeedButton;
    BnCompile: TSpeedButton;
    BnRunDosBox: TSpeedButton;
    PanelExpand: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    MainMenu1: TMainMenu;
    MainDatei: TMenuItem;
    MnNeu: TMenuItem;
    MnOeffnen: TMenuItem;
    N1: TMenuItem;
    MnTaschenrechner: TMenuItem;
    MnDOSEbene: TMenuItem;
    MnExplorer: TMenuItem;
    MnNotepad: TMenuItem;
    N3: TMenuItem;
    MnExit: TMenuItem;
    MnStrichAlteDateien: TMenuItem;
    MnAlteDatei1: TMenuItem;
    MnAlteDatei2: TMenuItem;
    MnAlteDatei3: TMenuItem;
    MnAlteDatei4: TMenuItem;
    MnAlteDatei5: TMenuItem;
    MnAlteDatei6: TMenuItem;
    MnAlteDatei7: TMenuItem;
    MnAlteDatei8: TMenuItem;
    MnAlteDatei9: TMenuItem;
    MainOptionen: TMenuItem;
    MnEinstellungen: TMenuItem;
    MainFenster: TMenuItem;
    MnVorherigesFenster: TMenuItem;
    MnNaechstesFenster: TMenuItem;
    N4: TMenuItem;
    MnFensterTeilen: TMenuItem;
    MnFensterVertikalteilen: TMenuItem;
    MnFensterKaskade: TMenuItem;
    MnAlleSymboleanordnen: TMenuItem;
    MainHilfe: TMenuItem;
    MnProduktInfo: TMenuItem;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    MainMemo: TRichEdit;
    Timer1: TTimer;
    bnSaveAllFiles: TSpeedButton;
    mainFontsize: TMenuItem;
    mnFont8pg: TMenuItem;
    mnFont10pg: TMenuItem;
    mnFont11pg: TMenuItem;
    mnFont12pg: TMenuItem;
    mnFont14pg: TMenuItem;
    mnFont16pg: TMenuItem;
    mnFont18pg: TMenuItem;
    mnFont20pg: TMenuItem;
    mnFont22pg: TMenuItem;
    mnFont24pg: TMenuItem;
    mnFont26pg: TMenuItem;
    mnFont28pg: TMenuItem;
    mnFont30pg: TMenuItem;
    mainTabwidth: TMenuItem;
    mnTabwidth_1: TMenuItem;
    mnTabwidth_2: TMenuItem;
    mnTabwidth_3: TMenuItem;
    mnTabwidth_4: TMenuItem;
    mnTabwidth_5: TMenuItem;
    Label1: TLabel;
    spTabWidth: TSpinEdit;
    bnSetTabWidth: TSpeedButton;
    procedure MnNeuClick(Sender: TObject);
    procedure MnOeffnenClick(Sender: TObject);
    procedure MnTaschenrechnerClick(Sender: TObject);
    procedure MnDOSEbeneClick(Sender: TObject);
    procedure MnExplorerClick(Sender: TObject);
    procedure MnNotepadClick(Sender: TObject);
    procedure MnExitClick(Sender: TObject);
    procedure MnEinstellungenClick(Sender: TObject);
    procedure MnVorherigesFensterClick(Sender: TObject);
    procedure MnNaechstesFensterClick(Sender: TObject);
    procedure MnFensterTeilenClick(Sender: TObject);
    procedure MnFensterVertikalteilenClick(Sender: TObject);
    procedure MnFensterKaskadeClick(Sender: TObject);
    procedure MnAlleSymboleanordnenClick(Sender: TObject);
    procedure MnProduktInfoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BnUndoClick(Sender: TObject);
    procedure BnCutClick(Sender: TObject);
    procedure BnCopyClick(Sender: TObject);
    procedure BnPasteClick(Sender: TObject);
    procedure BnCompileClick(Sender: TObject);
    procedure BnRunDosBoxClick(Sender: TObject);
    procedure BnSaveFileClick(Sender: TObject);
    procedure bnSaveAllFilesClick(Sender: TObject);
    procedure mnFont8pgClick(Sender: TObject);
    procedure mnFont10pgClick(Sender: TObject);
    procedure mnFont11pgClick(Sender: TObject);
    procedure mnFont12pgClick(Sender: TObject);
    procedure mnFont14pgClick(Sender: TObject);
    procedure mnFont16pgClick(Sender: TObject);
    procedure mnFont18pgClick(Sender: TObject);
    procedure mnFont20pgClick(Sender: TObject);
    procedure mnFont22pgClick(Sender: TObject);
    procedure mnFont24pgClick(Sender: TObject);
    procedure mnFont26pgClick(Sender: TObject);
    procedure mnFont28pgClick(Sender: TObject);
    procedure mnFont30pgClick(Sender: TObject);
    procedure bnSetTabWidthClick(Sender: TObject);
  private
    { Private-Deklarationen }
    _EditorPfad:string;
    _StartenFertig:boolean;

    _Filter:string;
    _Filtermask:string;
    _Ext:string;

    //_WindowList:TList;

    procedure OpenFilename(filename:string);
    procedure LoadFilename(filename:string);
    procedure setFont(fontsize:integer);
    function  getActiveChildForm():TFMDIDEdit;
  public
    { Public-Deklarationen }
    procedure SaveAllMDIWindows;
    procedure CloseAllWindows;
  end;

var
  FMain: TFMain;

implementation

{$R *.dfm}


uses math,
     shellapi,
     PythonIDE_bas,
     PythonIDE_var,
     start;
//, DDoc;


procedure TFMain.FormCreate(Sender: TObject);
begin
  //_WindowList:=TList.create;  // Speichert die Adressen
  G_EditorPath := G_Path;
  _EditorPfad := G_Path;

  _Filter:= 'Python-Dateien (*.py)|Alle Dateien (*.*)|*.*';
  _Filtermask := '*.Py';


  readConfiguration;


  StatusBar1.Panels.Items[0].Text  := ' ';
  StatusBar1.Panels.Items[1].Text  := ' ';
  StatusBar1.Panels.Items[2].Text  := '';
  StatusBar1.Panels.Items[3].Text  := '';

  _StartenFertig :=false;


  _StartenFertig:=true;
  if Paramcount>0 then Timer1.enabled := true;
end;


procedure TFMain.MnNeuClick(Sender: TObject);
begin
  LoadFilename('');
end;

procedure TFMain.MnOeffnenClick(Sender: TObject);
var szAktPfad:String;
    i:integer;
begin
  getDir(0,szAktPfad);

  OpenDialog1.Title := 'Datei ffnen';

  OpenDialog1.DefaultExt := '.py';
  OpenDialog1.FileName:= '*.py';
  OpenDialog1.Filter := 'Python (*.py)|*.py|Alle Dateien (*.*)|*.*';
  OpenDialog1.InitialDir := _EditorPfad;

  OpenDialog1.Options :=  [ofEnableSizing, ofAllowMultiSelect, ofPathMustExist,ofShowHelp];

  if OpenDialog1.Execute then
  begin
    with OpenDialog1.Files do
    begin
      // FileListebox.Items := OpenDialog1.Files;
      for I:=Count-1 downto 0 do
      begin
        OpenFilename(Strings[i]);
      end;
    end;
    // Meldung('ready','');
  end;
  chDir(szAktPfad);
  OpenDialog1.Options :=  [ofEnableSizing, ofShowHelp];
end;

procedure TFMain.OpenFilename(filename:string);
var szZ, szPfad, szName, szExt:String;
    i:integer;
    pF:TFMDIDEdit;
begin
  if not FileExists(filename) then
  begin
    Msgbox('Datei ffnen','Die Datei'+NL+ filename+NL+'existiert nicht');
    exit;
  end;
  fsplit(filename,szPfad, szName,szExt);
  _StartenFertig:=false;

  _StartenFertig:=true;

  szZ := AnsiUppercase(filename);
  for i:=0 to self.MDIChildCount-1 do
  begin
    pF := TFMDIDEdit(self.MDIChildren[i]);
    if AnsiUppercase(pF.getFileName) = szZ then
    begin
      Msgbox('Hinweis','Datei ist schon geladen'+NL+filename);
      exit;
    end;
  end;
  LoadFilename( filename );
end;  // OeffneDatei


procedure TFMain.MnTaschenrechnerClick(Sender: TObject);
begin
  if ExecuteFile('Calc.exe', '', '', SW_SHOW)<=32 then
  begin
    Errorbox('Fehler','Fehler beim Aufruf des Taschenrechners');
  end;
end;

procedure TFMain.MnDOSEbeneClick(Sender: TObject);
var sVerz, szZ:string;
    pF:TFMDIDEdit;
begin
  szZ := getComspec;

  if self.MDIChildCount=0 then
  begin
     sVerz := G_Path;
  end
  else
  begin
    pF := TFMDIDEdit(self.MDIChildren[0]);
    if pF.WindowState <> wsMinimized then
    begin
      sVerz := pF.getPath();
      if sVerz='' then sVerz := G_Path;
    end
    else
    begin
      sVerz := G_Path;
    end;
  end;

  if  ShellExecute(Application.MainForm.Handle, nil,
      PChar(szZ), PChar(''), PChar(sVerz), SW_SHOW) <= 32 then
  begin
    Msgbox('Fehler', 'Fehler: '+IntToStr(handle));
  end;
end;

procedure TFMain.MnExplorerClick(Sender: TObject);
begin
 if ExecuteFile('Explorer.exe', '', '', SW_SHOW)<=32 then
  begin
    Errorbox('Fehler','Fehler beim Aufruf des Explorers');
  end;
end;

procedure TFMain.MnNotepadClick(Sender: TObject);
begin
  if ExecuteFile('Notepad.exe', '', '', SW_SHOW)<=32 then
  begin
    Errorbox('Fehler','Fehler beim Aufruf des Notepads');
  end;
end;

procedure TFMain.MnExitClick(Sender: TObject);
begin
  Close();
end;

procedure TFMain.MnEinstellungenClick(Sender: TObject);
begin
//
end;

procedure TFMain.MnVorherigesFensterClick(Sender: TObject);
begin
  previous;
end;

procedure TFMain.MnNaechstesFensterClick(Sender: TObject);
begin
  next;
end;

procedure TFMain.MnFensterTeilenClick(Sender: TObject);
begin
  tile;
end;

procedure TFMain.MnFensterVertikalteilenClick(Sender: TObject);
var Hoffset, HStbar, h0, wi, w0, w, n, i:integer;
    pF:TFMDIDEdit;
begin
  Tile;

  n := 0;
  for i:=0 to self.MDIChildCount-1 do
  begin
    pF := TFMDIDEdit(self.MDIChildren[i-1]);
    if pF.WindowState <> wsMinimized then inc(n,1);
  end;
  if n = 0 then exit;

  if Panel1.Visible
  then h0 := Panel1.Height+1
  else h0 := 0;

  if StatusBar1.Visible
  then HStbar:=StatusBar1.Height
  else HStbar := 0;


  if (H0=0) and (HStBar=0)
  then HOffset := 6
  else HOffset := 10;

  w  := (Clientwidth-n-n) div n;
  w0 := (Clientwidth-n-n) mod n;

  wi:= 0;
  for i:=0 to self.MDIChildCount-1 do
  begin
    pF := TFMDIDEdit(self.MDIChildren[i]);
    if pF.WindowState <> wsMinimized then
    begin
        pF.left := wi;
        pF.Top := h0;
        pF.Top := 0;
        pF.Height := Clientheight - (h0+HStbar) - Hoffset;
        if i = 1 then
        begin
          pF.width := w+w0;
          wi := wi + w + w0;
        end
        else
        begin
          pF.width := w;
          wi := wi + w;
        end;
    end;
  end;  // for
end;

procedure TFMain.MnFensterKaskadeClick(Sender: TObject);
begin
  cascade;
end;

procedure TFMain.MnAlleSymboleanordnenClick(Sender: TObject);
begin
    ArrangeIcons;
end;

procedure TFMain.MnProduktInfoClick(Sender: TObject);
var f:TFStart;
begin
  f:=TFStart.create(Application);
  try
    f.showmodal;
  finally
    f.Free;
  end;
end;


procedure TFMain.SaveAllMDIWindows;
var i:integer;
    pF:TFMDIDEdit;
begin
  for i:=0 to self.MDIChildCount-1 do
  begin
    pF := TFMDIDEdit(self.MDIChildren[i]);
    pF.MnSaveClick(self);
  end;
end;

procedure TFMain.CloseAllWindows;
var i:integer;
    pF:TFMDIDEdit;
begin
  for i:=0 to self.MDIChildCount-1 do
  begin
    pF := TFMDIDEdit(self.MDIChildren[i]);
    pF.close;
  end;
end;  // Close All

procedure TFMain.LoadFilename(filename:string);
var szPfad, szName, szExt:String;
var f:TFMDIDEdit;
begin
  fsplit(filename, szPfad, szName, szExt);
  _Ext := szExt;
  if length(filename)>0 then
  begin
    G_EditorPath := szPfad;
    PythonIDE_bas.saveConfiguration();
  end;

  f:=TFMDIDEdit.Create(Application);
  try
    f.Init(filename);
  finally
  end;
end;  //  MnEditorDateiladen



procedure TFMain.Timer1Timer(Sender: TObject);
var i:integer;
begin
  Timer1.enabled := false;
  for i:=1 to Paramcount do
  begin
    if FileExists(ParamStr(i)) then
    begin
      LoadFilename( ParamStr(i) );
    end;
  end;
end;

function TFmain.getActiveChildForm():TFMDIDEdit;
begin
  if MDIChildCount=0
  then result:=nil
  else result := TFMDIDEdit(self.MDIChildren[0]);
end;

procedure TFMain.BnUndoClick(Sender: TObject);
var f:TFMDIDEdit;
begin
  f:=getActiveChildForm();
  if f<>nil then
  begin
    f.mnUndoClick(Sender);
  end;
end;

procedure TFMain.BnCutClick(Sender: TObject);
var f:TFMDIDEdit;
begin
  f:=getActiveChildForm();
  if f<>nil then
  begin
    f.mnCutClick(Sender);
  end;
end;

procedure TFMain.BnCopyClick(Sender: TObject);
var f:TFMDIDEdit;
begin
  f:=getActiveChildForm();
  if f<>nil then
  begin
    f.mnCopyClick(Sender);
  end;
end;

procedure TFMain.BnPasteClick(Sender: TObject);
var f:TFMDIDEdit;
begin
  f:=getActiveChildForm();
  if f<>nil then
  begin
    f.mnPasteClick(Sender);
  end;
end;

procedure TFMain.BnCompileClick(Sender: TObject);
var f:TFMDIDEdit;
begin
  f:=getActiveChildForm();
  if f<>nil then
  begin
    f.mnPythonDirektClick(Sender);
  end;
end;

procedure TFMain.BnRunDosBoxClick(Sender: TObject);
var f:TFMDIDEdit;
begin
  f:=getActiveChildForm();
  if f<>nil then
  begin
    f.mnPythonWithDosBoxClick(Sender);
  end;
end;

procedure TFMain.BnSaveFileClick(Sender: TObject);
var f:TFMDIDEdit;
begin
  f:=getActiveChildForm();
  if f<>nil then
  begin
    f.MnSaveClick(sender);
  end;
end;

procedure TFMain.bnSaveAllFilesClick(Sender: TObject);
var i,n:integer;
    pF:TFMDIDEdit;
begin
  n := self.MDIChildCount;
  for i:=0 to n-1 do
  begin
    pF:= TFMDIDEdit(self.MDIChildren[i]);
    pF.MnsaveClick(sender);
  end;
end;


procedure TFMain.setFont(fontsize:integer);
var i,n:integer;
    pF:TFMDIDEdit;
begin
  n := self.MDIChildCount;
  for i:=0 to n-1 do
  begin
    pF:= TFMDIDEdit(self.MDIChildren[i]);
    pF.setFontsize(fontsize);
  end;
end;


procedure TFMain.bnSetTabWidthClick(Sender: TObject);
var i,n:integer;
    pF:TFMDIDEdit;
begin
  n := self.MDIChildCount;
  for i:=0 to n-1 do
  begin
    pF:= TFMDIDEdit(self.MDIChildren[i]);
    pF.setTabwidth(spTabWidth.Value);
    G_TabWidth := spTabWidth.Value;
    PythonIDE_bas.saveConfiguration();
  end;
end;


procedure TFMain.mnFont8pgClick(Sender: TObject);
begin
  setFont(8);
end;

procedure TFMain.mnFont10pgClick(Sender: TObject);
begin
  setFont(10);
end;

procedure TFMain.mnFont11pgClick(Sender: TObject);
begin
  setFont(11);
end;

procedure TFMain.mnFont12pgClick(Sender: TObject);
begin
  setFont(12);
end;

procedure TFMain.mnFont14pgClick(Sender: TObject);
begin
  setFont(14);
end;

procedure TFMain.mnFont16pgClick(Sender: TObject);
begin
  setFont(16);
end;

procedure TFMain.mnFont18pgClick(Sender: TObject);
begin
  setFont(18);
end;

procedure TFMain.mnFont20pgClick(Sender: TObject);
begin
  setFont(20);
end;

procedure TFMain.mnFont22pgClick(Sender: TObject);
begin
  setFont(22);
end;

procedure TFMain.mnFont24pgClick(Sender: TObject);
begin
  setFont(24);
end;

procedure TFMain.mnFont26pgClick(Sender: TObject);
begin
  setFont(26);
end;

procedure TFMain.mnFont28pgClick(Sender: TObject);
begin
  setFont(28);
end;

procedure TFMain.mnFont30pgClick(Sender: TObject);
begin
  setFont(30);
end;


end.

